#ifndef doc_cel_data_h
#define doc_cel_data_h

#include "base/shared_ptr.h"
#include "image_ref.h"
#include "with_user_data.h"

namespace doc{
    struct Position{
        Position(int _x,int _y):x(_x),y(_y){}
        int x;
        int y;
    };

    class CelData : public WithUserData{
    private:
        ImageRef _image;
        Position _position;
        int _opacity;
    public:
        CelData(const ImageRef &img):_image(img),_position(0,0),_opacity(255){}
        const Position &position() const { return _position; }
        void setPosition(int x,int y) { _position.x = x; _position.y = y; }
        int opacity() const { return _opacity; }
        void setOpacity(int o) { _opacity = o; }
        Image *image() const { return const_cast<Image*>(_image.get()); }
    };

    typedef base::SharedPtr<CelData> CelDataRef;
}

#endif /* doc_cel_data_h */
