#ifndef doc_palette_h
#define doc_palette_h

#include <vector>

#include "color.h"

namespace doc{
    class Palette{
        std::vector<color_t> _colors;
        int _frame;
    public:
        Palette(int frame, int colors);
        Palette(const Palette&);
        int size() const { return (int)_colors.size(); }
        void resize(int);

        int frame() const { return _frame; }
        void setFrame(int f) { _frame = f; }

        color_t getEntry(int i) const { return i>=0 && i<size() ? _colors[i] : 0; }
        void setEntry(int i, color_t);

        void copyColorsTo(Palette*) const;

        int countDiff(const Palette *other, int *from, int *to) const;
    };
}

#endif /* doc_palette_h */
