#ifndef doc_primitives_fast_h
#define doc_primitives_fast_h

namespace doc{
    class Image;
    template<typename ImageTraits> class ImageImpl;

    template<class Traits>
    inline typename Traits::address_t get_pixel_address_fast(const Image *img,int x,int y){
        return (((ImageImpl<Traits>*)img)->address(x,y));
    }

    template<class Traits>
    inline typename Traits::pixel_t get_pixel_fast(const Image *img, int x, int y){
        return *(((ImageImpl<Traits>*)img)->address(x,y));
    }

    template<class Traits>
    inline void put_pixel_fast(Image *img, int x, int y, typename Traits::pixel_t color){
        *(((ImageImpl<Traits>*)img)->address(x,y)) = color;
    }
}

#endif /* doc_primitives_fast_h */
