/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef nil_c64_h
#define nil_c64_h

#include "nile.h"

typedef enum{
    NIL_C64_COLODORE,
    NIL_C64_GODOT,
    NIL_C64_PEPTO
}nil_c64_palette_t;

typedef struct{
    uint8_t bitmap[8000];
    uint8_t screen[1000];
    uint8_t color[1000];
    uint8_t background;
}nil_c64_vram_t;

void nil_c64_copy_palette_colors(uint8_t *dst, int dst_bpc, nile_format_t dst_format, nil_c64_palette_t, int count);
int nil_c64_palette(nile_t*,nil_c64_palette_t);
int nil_c64_decode(nile_t*,const uint8_t *bitmap, const uint8_t *screen, const uint8_t *color, int background);
int nil_c64_vram_decode(nile_t*,const nil_c64_vram_t*);

#endif /* nil_c64_h */
