/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef loa_abstract_h
#define loa_abstract_h

#include "nil-clip.h"

#define LOA_ABSTRACT_FLIP_HORIZONTAL (1<<0)
#define LOA_ABSTRACT_FLIP_VERTICAL   (1<<1)
#define LOA_ABSTRACT_MASK_COLOR      (1<<2)
#define LOA_ABSTRACT_MASK_ALPHA      (1<<3)
#define LOA_ABSTRACT_TILE            (1<<4)
#define LOA_ABSTRACT_REPLACE         (1<<5)
#define LOA_ABSTRACT_UNDER           (1<<6)
#define LOA_ABSTRACT_ADD             (1<<7)

typedef struct _loa_abstract_t loa_abstract_t;

typedef void(*loa_abstract_free_func_t)(void*, loa_abstract_t*);

typedef struct{
    loa_abstract_t*(*create)(void *userdata, int width, int height);
    loa_abstract_free_func_t free;
    void(*get_size)(void *userdata, loa_abstract_t*, int *width, int *height);
    loa_abstract_t*(*copy)(void *userdata, loa_abstract_t*, int deep);
    void(*fill)(void *userdata, loa_abstract_t*, double r, double g, double b, double a, nil_clip_t*);
    void(*paste)(void *userdata, loa_abstract_t *dst, double x, double y, double xscale, double yscale, int flags, loa_abstract_t *src, nil_clip_t*);
}loa_abstract_interface_t;

#endif /* loa_abstract_h */
