/*
 * Copyright (C) 2021  Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include <debug.h>
#include <string.h>

#include "svgcolor.h"
#include "svgcolor.yy.h"


#if 0
#define COLOR_COUNT 147


static const svg_color_t svg_color[COLOR_COUNT] = {
    {"black", 0x000000},
    {"navy", 0x000080},
    {"darkblue", 0x00008B},
    {"mediumblue", 0x0000CD},
    {"blue", 0x0000FF},
    {"darkgreen", 0x006400},
    {"green", 0x008000},
    {"teal", 0x008080},
    {"darkcyan", 0x008B8B},
    {"deepskyblue", 0x00BFFF},
    {"darkturquoise", 0x00CED1},
    {"mediumspringgreen", 0x00FA9A},
    {"lime", 0x00FF00},
    {"springgreen", 0x00FF7F},
    {"cyan", 0x00FFFF},
    {"aqua", 0x00FFFF},
    {"midnightblue", 0x191970},
    {"dodgerblue", 0x1E90FF},
    {"lightseagreen", 0x20B2AA},
    {"forestgreen", 0x228B22},
    {"seagreen", 0x2E8B57},
    {"darkslategray", 0x2F4F4F},
    {"darkslategrey", 0x2F4F4F},
    {"limegreen", 0x32CD32},
    {"mediumseagreen", 0x3CB371},
    {"turquoise", 0x40E0D0},
    {"royalblue", 0x4169E1},
    {"steelblue", 0x4682B4},
    {"darkslateblue", 0x483D8B},
    {"mediumturquoise", 0x48D1CC},
    {"indigo", 0x4B0082},
    {"darkolivegreen", 0x556B2F},
    {"cadetblue", 0x5F9EA0},
    {"cornflowerblue", 0x6495ED},
    {"mediumaquamarine", 0x66CDAA},
    {"dimgrey", 0x696969},
    {"dimgray", 0x696969},
    {"slateblue", 0x6A5ACD},
    {"olivedrab", 0x6B8E23},
    {"slategrey", 0x708090},
    {"slategray", 0x708090},
    {"lightslategray", 0x778899},
    {"lightslategrey", 0x778899},
    {"mediumslateblue", 0x7B68EE},
    {"lawngreen", 0x7CFC00},
    {"chartreuse", 0x7FFF00},
    {"aquamarine", 0x7FFFD4},
    {"maroon", 0x800000},
    {"purple", 0x800080},
    {"olive", 0x808000},
    {"gray", 0x808080},
    {"grey", 0x808080},
    {"skyblue", 0x87CEEB},
    {"lightskyblue", 0x87CEFA},
    {"blueviolet", 0x8A2BE2},
    {"darkred", 0x8B0000},
    {"darkmagenta", 0x8B008B},
    {"saddlebrown", 0x8B4513},
    {"darkseagreen", 0x8FBC8F},
    {"lightgreen", 0x90EE90},
    {"mediumpurple", 0x9370DB},
    {"darkviolet", 0x9400D3},
    {"palegreen", 0x98FB98},
    {"darkorchid", 0x9932CC},
    {"yellowgreen", 0x9ACD32},
    {"sienna", 0xA0522D},
    {"brown", 0xA52A2A},
    {"darkgray", 0xA9A9A9},
    {"darkgrey", 0xA9A9A9},
    {"lightblue", 0xADD8E6},
    {"greenyellow", 0xADFF2F},
    {"paleturquoise", 0xAFEEEE},
    {"lightsteelblue", 0xB0C4DE},
    {"powderblue", 0xB0E0E6},
    {"firebrick", 0xB22222},
    {"darkgoldenrod", 0xB8860B},
    {"mediumorchid", 0xBA55D3},
    {"rosybrown", 0xBC8F8F},
    {"darkkhaki", 0xBDB76B},
    {"silver", 0xC0C0C0},
    {"mediumvioletred", 0xC71585},
    {"indianred", 0xCD5C5C},
    {"peru", 0xCD853F},
    {"chocolate", 0xD2691E},
    {"tan", 0xD2B48C},
    {"lightgray", 0xD3D3D3},
    {"lightgrey", 0xD3D3D3},
    {"thistle", 0xD8BFD8},
    {"orchid", 0xDA70D6},
    {"goldenrod", 0xDAA520},
    {"palevioletred", 0xDB7093},
    {"crimson", 0xDC143C},
    {"gainsboro", 0xDCDCDC},
    {"plum", 0xDDA0DD},
    {"burlywood", 0xDEB887},
    {"lightcyan", 0xE0FFFF},
    {"lavender", 0xE6E6FA},
    {"darksalmon", 0xE9967A},
    {"violet", 0xEE82EE},
    {"palegoldenrod", 0xEEE8AA},
    {"lightcoral", 0xF08080},
    {"khaki", 0xF0E68C},
    {"aliceblue", 0xF0F8FF},
    {"honeydew", 0xF0FFF0},
    {"azure", 0xF0FFFF},
    {"sandybrown", 0xF4A460},
    {"wheat", 0xF5DEB3},
    {"beige", 0xF5F5DC},
    {"whitesmoke", 0xF5F5F5},
    {"mintcream", 0xF5FFFA},
    {"ghostwhite", 0xF8F8FF},
    {"salmon", 0xFA8072},
    {"antiquewhite", 0xFAEBD7},
    {"linen", 0xFAF0E6},
    {"lightgoldenrodyellow", 0xFAFAD2},
    {"oldlace", 0xFDF5E6},
    {"red", 0xFF0000},
    {"fuchsia", 0xFF00FF},
    {"magenta", 0xFF00FF},
    {"deeppink", 0xFF1493},
    {"orangered", 0xFF4500},
    {"tomato", 0xFF6347},
    {"hotpink", 0xFF69B4},
    {"coral", 0xFF7F50},
    {"darkorange", 0xFF8C00},
    {"lightsalmon", 0xFFA07A},
    {"orange", 0xFFA500},
    {"lightpink", 0xFFB6C1},
    {"pink", 0xFFC0CB},
    {"gold", 0xFFD700},
    {"peachpuff", 0xFFDAB9},
    {"navajowhite", 0xFFDEAD},
    {"moccasin", 0xFFE4B5},
    {"bisque", 0xFFE4C4},
    {"mistyrose", 0xFFE4E1},
    {"blanchedalmond", 0xFFEBCD},
    {"papayawhip", 0xFFEFD5},
    {"lavenderblush", 0xFFF0F5},
    {"seashell", 0xFFF5EE},
    {"cornsilk", 0xFFF8DC},
    {"lemonchiffon", 0xFFFACD},
    {"floralwhite", 0xFFFAF0},
    {"snow", 0xFFFAFA},
    {"yellow", 0xFFFF00},
    {"lightyellow", 0xFFFFE0},
    {"ivory", 0xFFFFF0},
    {"white", 0xFFFFFF}
};
#endif

#if 0
const svg_color_t *
svg_color_lookup(const char* name)
{
    int i;
    for(i=0;i<COLOR_COUNT;++i)
        if(!strcasecmp(name, svg_color[i].name))
            return &svg_color[i];
    return 0;
}
#endif


/*
static int
_on_x(struct val_s *v)
{
}
*/


int
svgcolorwrap(yyscan_t scanner)
{
    printf("wrap\n");
    return 1;
}


static void
_on_color(svg_color_context_t *p, uint32_t val)
{
    DEBUG_p("begin");
    p->color->r = (double)((val>>16)&255)/255;
    p->color->g = (double)((val>>8)&255)/255;
    p->color->b = (double)((val>>0)&255)/255;
}


static void
_on_hex3(svg_color_context_t *p, const char *s)
{
    DEBUG_p("begin");
    _color_set_hexstring(p->color, s);
}


static void
_on_hex6(svg_color_context_t *p, const char *s)
{
    DEBUG_p("begin");
    _color_set_hexstring(p->color, s);
}


static void
_on_channel(svg_color_context_t *p, double val)
{
    DEBUG_p("value = %f, channel = %d", val, p->channel);
    switch(p->channel){
    case 0:
        p->color->r = val;
        break;
    case 1:
        p->color->g = val;
        break;
    case 2:
        p->color->b = val;
        break;
    }
    ++p->channel;
}


int
svg_color_parse(svg_color_parser_t *p, color_t *color, const char *s, ssize_t len)
{
    static const svg_color_interface_t svg_color_vt = {
        .color = _on_color,
        .hex3 = _on_hex3,
        .hex6 = _on_hex6,
        .channel = _on_channel
    };
    svg_color_context_t c;
    YY_BUFFER_STATE buf;
    c.vt = &svg_color_vt;
    c.color = color;
    c.channel = 0;
    if(len>=0){
        buf = svgcolor_scan_bytes(s, len, p->scanner);
    }else{
        buf = svgcolor_scan_string(s, p->scanner);
    }
    svgcolorlex(&c, p->scanner);
    svgcolor_delete_buffer(buf, p->scanner);
    return 0;
}
