/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#ifndef SHR3DECOMPRESSOR_HPP
#define SHR3DECOMPRESSOR_HPP

#include "dec.h"

class SHR3Decompressor : public XPKDecompressor
{
private:
	class SHR3State : public XPKDecompressor::State
	{
	public:
		SHR3State() noexcept;
		virtual ~SHR3State();

		uint32_t vlen=0;
		uint32_t vnext=0;
		uint32_t shift=0;
		uint32_t ar[999];
	};

public:
	SHR3Decompressor(const Buffer &packedData,std::unique_ptr<XPKDecompressor::State> &state);
	virtual ~SHR3Decompressor(){}

	virtual void decompressImpl(Buffer &rawData,const Buffer &previousData,bool verify) override final;

private:
	uint32_t				_ver=0;

	std::unique_ptr<XPKDecompressor::State>	&_state;	// reference!!!
};

#endif
