/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef nil_amiga_h
#define nil_amiga_h

#include "nile.h"

#include <stdint.h>

/* #define AMIGA_CAIRO_BITS16 */

#define BPLCON0_ECSENA (1<<0)
#define BPLCON0_ERSY   (1<<1)
#define BPLCON0_LACE   (1<<2)
#define BPLCON0_LPEN   (1<<3)
#define BPLCON0_BPU3   (1<<4)
#define BPLCON0_BYPASS (1<<5)
#define BPLCON0_SHRES  (1<<6)
#define BPLCON0_UHRES  (1<<7)
#define BPLCON0_GAUD   (1<<8)
#define BPLCON0_COLOR  (1<<9)
#define BPLCON0_DPF    (1<<10)
#define BPLCON0_HAM    (1<<11)
#define BPLCON0_BPUx   (7<<12)
#define BPLCON0_HIRES  (1<<15)

#define nil_amiga_plane_stride(w) (((w-1)/16+1)*2)

void nil_amiga_copy_colors(uint8_t *dst, int bpc, nile_format_t, const uint16_t *src, int count);

void amiga_decode_palette(uint8_t *palette, int bpc, nile_format_t, const uint16_t *amiga_palette, int colors);
//void amiga_decode_line(uint8_t **amiga_bitplane, uint8_t *dst, int bplcon0, const uint8_t *palette, int bpc);
//cairo_surface_t *abydos_image_surface_create_from_bitplanes(const uint8_t **bitplane, int width, int height, int depth, const amiga_cairo_color_t *palette, int palette_stepping);
//cairo_surface_t *abydos_image_surface_create_from_amiga_bitplanes(const uint8_t **bitplane, int width, int height, int depth, int bplcon0, const amiga_cairo_color_t *, int colors, int palette_stepping);
//cairo_surface_t *amiga_decode_image(const uint8_t **amiga_bitplane, const amiga_cairo_color_t *palette);
//cairo_surface_t *abydos_image_surface_create_from_amiga_pixels(const uint8_t *pixels, int width, int height, int stride, int bplcon0, amiga_cairo_color_t *palette, int palette_stepping);

nile_blit_t *nil_amiga_blit_init_bitplanes(nile_blit_t *,int dst_bpc, nile_format_t dst_format, int depth, const uint8_t *palette, int colors, int src_bpc, nile_format_t src_format, int bplcon0);
void nil_amiga_blit_direct_from_bitplanes(uint8_t *dst, int dst_stride, int dst_bpc, nile_format_t dst_format, uint8_t **src, int src_stride, int depth, const uint8_t *palette, int colors, int src_bpc, nile_format_t src_format, int width, int height, int bplcon0, int palette_stepping, int flags);

//void nil_amiga_planar_from_ehb_bitplanes(nile_t*, int palette_stepping);
//void nil_amiga_planar_from_ham_bitplanes(nile_t*, int palette_stepping);
//void nil_amiga_planar_from_bitplanes(nile_t*, int bplcon0, int palette_stepping);

//int nil_amiga_is_dctv(const nile_t *ni, int offs);
int nil_amiga_is_dctv(const nile_t *, uint32_t bplcon0);
int nil_amiga_decode_dctv(nile_t *, const nile_t *, uint32_t bplcon0);

int nil_amiga_is_hame(const nile_t *, int offs);
void nil_amiga_direct_from_hame(nile_t *, const nile_t *, uint32_t bplcon0);

void nil_amiga_direct_from_bitplanes(nile_t *, const nile_t *, uint32_t bplcon0, int palette_stepping, int flags);

#endif /* nil_amiga_h */
